# -*- coding: utf-8 -*-
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    copyright            : (C) 2015 by Sandro Mani / Sourcepole AG
#    email                : smani@sourcepole.ch

from qgis.core import *
from qgis.gui import *
from PyQt4.QtCore import *
from PyQt4.QtGui import *
import os
import operator

instances = list()

translator = None


def init(dialog, layer, feature):
    global translator
    if not translator:
        locale = QSettings().value("locale/userLocale")[0:2]
        localePath = os.path.join(os.path.dirname(__file__), '..', 'i18n', 'lnfschwyz_{}.qm'.format(locale))

        if os.path.exists(localePath):
            translator = QTranslator()
            translator.load(localePath)
            QCoreApplication.installTranslator(translator)

    # Keep a reference alive
    global instances
    instances.append(CompanyDialog(dialog, layer, feature))


class CompanyDialog(QObject):
    def __init__(self, dialog, layer, feature):
        QObject.__init__(self)
        dialog.destroyed.connect(self.cleanup)

        for field in layer.pendingFields().toList():
            label = dialog.findChild(QLabel, "label_%s" % field.name())
            if label:
                label.setText(layer.attributeAlias(layer.pendingFields().indexFromName(field.name())))

    def cleanup(self):
        global instances
        instances.remove(self)
